EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_FILE_CREATED =
   EFL_EVENT_DESCRIPTION("file,created");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_FILE_DELETED =
   EFL_EVENT_DESCRIPTION("file,deleted");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_FILE_MODIFIED =
   EFL_EVENT_DESCRIPTION("file,modified");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_FILE_CLOSED =
   EFL_EVENT_DESCRIPTION("file,closed");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_DIRECTORY_CREATED =
   EFL_EVENT_DESCRIPTION("directory,created");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_DIRECTORY_DELETED =
   EFL_EVENT_DESCRIPTION("directory,deleted");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_DIRECTORY_MODIFIED =
   EFL_EVENT_DESCRIPTION("directory,modified");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_DIRECTORY_CLOSED =
   EFL_EVENT_DESCRIPTION("directory,closed");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_SELF_RENAME =
   EFL_EVENT_DESCRIPTION("self,rename");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_SELF_DELETED =
   EFL_EVENT_DESCRIPTION("self,deleted");
EIO_API EIO_API_WEAK const Efl_Event_Description _EIO_SENTRY_EVENT_ERROR =
   EFL_EVENT_DESCRIPTION("error");

Eina_Bool _eio_sentry_add(Eo *obj, Eio_Sentry_Data *pd, const char *path);

EIO_API EIO_API_WEAK EFL_FUNC_BODYV(eio_sentry_add, Eina_Bool, 0, EFL_FUNC_CALL(path), const char *path);

void _eio_sentry_remove(Eo *obj, Eio_Sentry_Data *pd, const char *path);

EIO_API EIO_API_WEAK EFL_VOID_FUNC_BODYV(eio_sentry_remove, EFL_FUNC_CALL(path), const char *path);

Eina_Bool _eio_sentry_fallback_check(const Eo *obj, Eio_Sentry_Data *pd, const char *path);

EIO_API EIO_API_WEAK EFL_FUNC_BODYV_CONST(eio_sentry_fallback_check, Eina_Bool, 0, EFL_FUNC_CALL(path), const char *path);

Efl_Object *_eio_sentry_efl_object_constructor(Eo *obj, Eio_Sentry_Data *pd);


void _eio_sentry_efl_object_destructor(Eo *obj, Eio_Sentry_Data *pd);


static Eina_Bool
_eio_sentry_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EIO_SENTRY_EXTRA_OPS
#define EIO_SENTRY_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(eio_sentry_add, _eio_sentry_add),
      EFL_OBJECT_OP_FUNC(eio_sentry_remove, _eio_sentry_remove),
      EFL_OBJECT_OP_FUNC(eio_sentry_fallback_check, _eio_sentry_fallback_check),
      EFL_OBJECT_OP_FUNC(efl_constructor, _eio_sentry_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _eio_sentry_efl_object_destructor),
      EIO_SENTRY_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _eio_sentry_class_desc = {
   EO_VERSION,
   "Eio.Sentry",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Eio_Sentry_Data),
   _eio_sentry_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(eio_sentry_class_get, &_eio_sentry_class_desc, EFL_OBJECT_CLASS, NULL);
